(*
    Id3Tag - Miscellaneous utilities
    Copyright (c) 1998-2002,2003 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit Tools;

interface

uses Id3;

const
  sTitle      = '%title%';
  sAlbum      = '%album%';
  sArtist     = '%artist%';
  sYear       = '%year%';
  sTrack      = '%track%';
  sComment    = '%comment%';
  sTabCols    = '%tablecols%';
  sTabRows    = '%tablerows%';
  sFilePath   = '%filepath%';
  sFileName   = '%filename%';
  sExpandTable= '<!--ID3TAG>';

function ReplaceId3Tokens( var S: string; Info: TId3Info ): boolean;
function StringReplace( var S: string; const Old, New: string ): boolean;

implementation

uses SysUtils;

(*
  Replaces string 'Old' with string 'New'.
  Returns FALSE if string 'Old' was found but string 'New'
  is empty.
*)
function StringReplace( var S: string; const Old, New: string ): boolean;
var
  I: integer;
begin
  Result := true;
  I := Pos( Old, LowerCase( S ) );
  if( I > 0 ) then begin
    if( New = '' ) then begin
      Result := false;
    end;
    Delete( S, I, Length(Old) );
    Insert( New, S, I );
  end;
end;

function ReplaceId3Tokens( var S: string; Info: TId3Info ): boolean;
var
  V: boolean;
begin
  V := StringReplace( S, sComment, Info.Comment );
  V := V and StringReplace( S, sTitle, Info.Title );
  V := V and StringReplace( S, sAlbum, Info.Album );
  V := V and StringReplace( S, sArtist, Info.Artist );
  V := V and StringReplace( S, sYear, Info.Year );
  if( Info.Track = 0 ) then
    V := V and StringReplace( S, sTrack, '' )
  else
    V := V and StringReplace( S, sTrack, Format('%.2d',[Info.Track]) );

  Result := V;
end;

end.
